/***********************************************************************************/
/**	\file				DataSet.cpp
**	\brief				Implementation zur Klasse DataSet
*************************************************************************************
**	Autor:				Christian Roesch
*************************************************************************************
**	-tut nichts-
**
*//*********************************************************************************/


// includes
#include "DataSet.h"

FrameWork::StatData FrameWork::DataSet::m_sdDummy;

// Methoden-Definitionen

namespace FrameWork
{

DataSet::DataSet()
{
}

DataSet::~DataSet()
{
	DataMapIterator it;
	
	for( 	it= m_mapData.begin();
			it != m_mapData.end();
			++it )
	{
		delete it->second;
	}
	m_mapData.clear();
}
	
void DataSet::addString( std::string strName, std::string strData )
{
	removeData( strName );
	
	StatDataString* sdsNew= new StatDataString( strData );
	m_mapData.insert( PairDataMap( strName, sdsNew ) );
}

std::string DataSet::getString( std::string strName )
{
	return getData( strName )->getString();
}

void DataSet::addFloat( std::string strName, float fData )
{
	removeData( strName );
	
	StatDataFloat* sdfNew= new StatDataFloat( fData );
	m_mapData.insert( PairDataMap( strName, sdfNew ) );
}

float DataSet::getFloat( std::string strName )
{
	return getData( strName )->getFloat();
}
	
StatData* DataSet::getData( std::string strName )
{
	DataMapIterator it= m_mapData.find( strName );
	if( it != m_mapData.end() )
	{
		return &(*(it->second));
	}
	return &m_sdDummy;
}

bool DataSet::ExistsData( std::string strName )
{
	DataMapIterator it= m_mapData.find( strName );
	return ( it != m_mapData.end() );
}

void DataSet::removeData( std::string strName )
{
	DataMapIterator it= m_mapData.find( strName );
	if( it != m_mapData.end() )
	{
		delete it->second;
		m_mapData.erase( it );
	}
}

std::vector< std::string > DataSet::getKeyList()
{
	std::vector< std::string > vecstrRet;
	DataMapIterator it;

	for( 	it= m_mapData.begin();
			it != m_mapData.end();
			++it )
	{
		vecstrRet.push_back( it->first );
	}

	return vecstrRet;
}

}

/************************************************************************************
**	Ende der Datei:		DataSet.cpp
************************************************************************************/
