/***********************************************************************************/
/**	\file				SimpleMenu.h
**	\brief				Header File zur Klasse SimpleMenu
*************************************************************************************
**	Autor:				Christian Roesch
*************************************************************************************
**	_tut nichts_
**
*//*********************************************************************************/

#ifndef _SimpleMenu_H
#define _SimpleMenu_H

// includes
#include "..\ComplexSurface.h"
#include "..\Font.h"
#include "..\GameState.h"
#include "..\Config.h"
#include "..\Mouse.h"

// Klassen-Deklaration

/***********************************************************************************/
/** \brief	SimpleMenu _tut nichts_
*************************************************************************************
**	Genau genommen _tut dies nichts_
**
*//*********************************************************************************/

class	SimpleMenu : public FrameWork::GameState
{
public:
	SimpleMenu( FrameWork::Config* pConfig, 
				FrameWork::Config* pSettings );
	~SimpleMenu();

	std::string getName() const;

	void onEnter( void* p_context );
	void onLeave( void* p_context, bool quit );
	void render( float dt );
	void update( float dt );

	bool isRestart();

protected:

private:
	enum Menus
	{
		MENU_MAIN,
		MENU_GFXOPTIONS,
		MENU_CREDITS
	};

	int getMenuLength( Menus eMenu );

	void getMenuTexts(	std::string& strFirst, 
						std::string& strSecond,
						Menus eMenu,
						int iIndex );

	bool isActiveMenu(	Menus eMenu,
						int iIndex );

	void activateMenu(	Menus eMenu,
						int iIndex );

	void changeMenu( Menus eNewMenu );
	
	void changeSelection( int iNew );
	void walkSelection( int iDir );

	void findActiveChoice( int iDir= 1 );

	void activateGfxOption( int iIndex );

	int findMouseSelection();

	Menus	m_eActiveMenu;
	int		m_iActiveChoice;

	FrameWork::ComplexSurface m_csArrow;
	FrameWork::ComplexSurface m_csMenu;

	FrameWork::Font* m_pFont1;
	FrameWork::Font* m_pFont2;

	float m_fArrowX;
	float m_fArrowY;
	float m_fMenuHeadX;
	float m_fMenuHeadY;
	float m_fMenuHeadSizeX;
	float m_fMenuHeadSizeY;

	float m_fMenuFirstX;
	float m_fMenuFirstY;
	float m_fMenuStep;

	float m_fMenuSizeX;
	float m_fMenuSizeY;

	float m_fScreenX;
	float m_fScreenY;
	FrameWork::Mouse m_Mouse;

	bool m_bRestart;
	
	FrameWork::Config* m_pConfig;
	FrameWork::Config* m_pSettings;

	std::vector< std::string > m_vecstrRules;
};

#endif//_SimpleMenu_H

class	SimpleMenu;


/************************************************************************************
**	Ende der Datei:		SimpleMenu.h
************************************************************************************/ 
