/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _ANIMATED_H
#define _ANIMATED_H

#include <string>
#include "timer.h"

namespace FrameWork
{
	class Animation;
	class AnimationSet;
	struct AnimationFrame;

	// Klasse fr ein animiertes Objekt
	class Animated
	{
	public:
		Animated(AnimationSet* p_animSet);
		~Animated();

		// setzt die aktuelle Animation
		void setAnimation(const std::string& name);

		// liefert das aktuelle Frame
		const AnimationFrame& getCurrentFrame();

		// spielt die Animation ab
		void play(float speed = 1.0f, bool loop = true);

		// hlt die Animation an
		void stop();

		// lsst die Animation weiterlaufen
		void resume();

		// setzt die aktuelle Animation zurck
		void resetAnimation();

		AnimationSet* getAnimationSet() {return p_animSet;}
		Animation* getCurrentAnimation() {return p_currentAnim;}
		bool isPlaying() const {return playing;}

	private:
		AnimationSet* p_animSet;
		Animation* p_currentAnim;
		Timer* p_timer;
		bool playing;
		bool loop;
	};
}

#endif
