/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include "animation.h"
using namespace std;

namespace FrameWork
{
	Animation::Animation(const string& name,
						 float speed)
	{
		this->name = name;
		this->speed = speed;
	}

	Animation::~Animation()
	{
	}

	void Animation::addFrame(const ivec2& coords,
							 const ivec2& size)
	{
		AnimationFrame frame;
		frame.coords = coords;
		frame.size = size;
		frames.push_back(frame);
	}

	void Animation::generateFrames(int num,
								   const ivec2& startCoords,
								   const ivec2& framesSize,
								   const ivec2& pitch,
								   int margin,
								   const ivec2& surfaceSize)
	{
		ivec2 coords = startCoords;
		for(int n = 0; n < num; n++)
		{
			// Frame erzeugen
			addFrame(coords, framesSize);

			// nchstes Frame vorbereiten
			coords.x += pitch.x;

			// Lge dieses Frame auerhalb der Oberflche?
			if(coords.x + framesSize.x >= surfaceSize.x)
			{
				// Ja - nchste Zeile!
				coords.x = margin;
				coords.y += pitch.y;
			}
		}
	}
}
