/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include <cassert>
#include "safe.h"
#include "audio.h"
#include "dsoundresource.h"
#include "graphics.h"
using namespace std;

namespace FrameWork
{
	Audio::Audio()
	{
		assert(Graphics::isInitialized());

		// DirectSound initialisieren, mit Standard-Ausgabegert
		HRESULT hres = DirectSoundCreate8(0, &p_dSound, 0);
		assert(SUCCEEDED(hres));
		assert(p_dSound);

		// Kooperationsebene setzen
		hres = p_dSound->SetCooperativeLevel(Graphics::inst().getWindow(), DSSCL_NORMAL);
		assert(SUCCEEDED(hres));

		// primren Soundpuffer erstellen
		DSBUFFERDESC bufferDesc;
		ZeroMemory(&bufferDesc, sizeof(bufferDesc));
		bufferDesc.dwSize = sizeof(bufferDesc);
		bufferDesc.dwFlags = DSBCAPS_PRIMARYBUFFER;
		hres = p_dSound->CreateSoundBuffer(&bufferDesc, &p_primaryBuffer, 0);
		assert(SUCCEEDED(hres));
		assert(p_primaryBuffer);
	}

	Audio::~Audio()
	{
		safeRelease(p_primaryBuffer);
		safeRelease(p_dSound);
	}
}
