/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _GAME_H
#define _GAME_H

#pragma warning(disable:4786)
#include <string>
#include <map>

namespace FrameWork
{
	class GameState;

	// Klasse fr ein Spiel
	class Game
	{
	public:
		Game(bool useFixedLogicStep = false, float fixedLogicStep = 0.0f);
		virtual ~Game();

		// registriert einen Spielzustand
		void registerGameState(GameState* p_gs);

		// setzt den aktuellen Spielzustand
		void setGameState(const std::string& gs, void* p_context = 0);

		// lsst das Spiel laufen
		void run();

		// beendet das Spiel
		void quit();

		// Pause
		void pause();

		// weiter
		void resume();

		bool isPaused() const {return paused;}
		GameState* getCurrentGameState() {return p_currentGS;}

	protected:
		bool useFixedLogicStep;
		float fixedLogicStep;
		float logicTimeLeft;
		bool paused;
		GameState* p_currentGS;
		std::map<std::string, GameState*> gameStates;
	};
}

#endif
