/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/
// modified 11.11.05 (TGGC)


#ifndef _SAFE_H
#define _SAFE_H

namespace FrameWork
{
	// sicheres Freigeben von COM-Schnittstellen
	template<typename T> void safeRelease(T& p_interface)
	{
		if(p_interface)
		{
			p_interface->Release();
			p_interface = 0;
		}
	}

	// sicheres Lschen eines Objekts
	template<typename T> void safeDelete(T& p_object)
	{
		delete p_object;
		p_object = 0;
	}

	// sicheres Lschen eines Arrays
	template<typename T> void safeDeleteArray(T& p_object)
	{
		delete[] p_object;
		p_object = 0;
	}
}

#endif
