/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/
// modified 12.11.05 (TGGC)


#ifndef _SINGLETON_H
#define _SINGLETON_H

#include <cassert>

namespace FrameWork
{
	// Singleton-Template-Klasse
	template <typename T> class Singleton
	{
	public:
		Singleton()
		{
			assert(!p_inst);
			if( p_inst != NULL )
			{
				delete p_inst;
			}

			p_inst = static_cast<T*>(this);
		}

		virtual ~Singleton()
		{
			p_inst = 0;
		}

		static T& inst()
		{
			assert(p_inst);
			return *p_inst;
		}

		static const T& cinst()
		{
			assert(p_inst);
			return *p_inst;
		}

		static void shutdown()
		{
			delete p_inst;
			p_inst= 0;
		}

		static bool isInitialized()
		{
			return p_inst != 0;
		}

		static void constructionFails()
		{
			p_inst= 0;
		}

	private:
		static T* p_inst;
	};

	template <typename T> T* Singleton<T>::p_inst= 0;
}

#endif
