/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#include "timer.h"
using namespace std;

namespace FrameWork
{
	list<Timer*> Timer::timers;

	Timer::Timer() : value(0.0f), speed(1.0f), running(true)
	{
		timers.push_back(this);
	}

	Timer::~Timer()
	{
		timers.remove(this);
	}

	void Timer::updateAllTimers(float dt)
	{
		for(list<Timer*>::iterator i = timers.begin(); i != timers.end(); i++)
		{
			(*i)->update(dt);
		}
	}

	void Timer::update(float dt)
	{
		if(running) value += dt * speed;
	}
}
