/*	                     __      __
	                     \ \    / /
	                      \ \  / /
	         _      _______\ \/ /_______      _
	        / \    / __________________ \    / \
	       (   \  | /        __        \ |  /   )
	     ___\  |  | |       / _\       | |  |  /___
	    |____  |  | |      ( <_        | |  | _____|
	      / \| |  | |       \__/       | |  | |/ \
	     / \ | |  | \__________________/ |  | | / \
	    /_/ \__/   \____________________/   \__/ \_\
	 ___  _   _ ___ __  __   _   _  _ ___   _     ____ __
	|   \| | | / __|  \/  | /_\ | \| |_ _| /_\   |__  /  \
	| |) | |_| \__ \ |\/| |/ _ \| .` || | / _ \    / / () |
	|___/ \___/|___/_|  |_/_/ \_\_|\_|___/_/ \_\  /_(_)__/

	      Framework fr den Spieleprogrammierwettbewerb
	             by David Scherfgen (TomasRiker)
*/

#ifndef _TIMER_H
#define _TIMER_H

#include <list>

namespace FrameWork
{
	// Klasse fr einen Timer
	class Timer
	{
	public:
		Timer();
		~Timer();

		static void updateAllTimers(float dt);

		void update(float dt);
		void setValue(float v) {value = v;}
		void setSpeed(float s) {speed = s;}
		void pause() {running = false;}
		void resume() {running = true;}
		float getValue() const {return value;}
		float getSpeed() const {return speed;}
		bool isRunning() const {return running;}

		operator float() const {return value;}
		float operator = (float f) {return value = f;}

	private:
		static std::list<Timer*> timers;

		float value, speed;
		bool running;
	};
}

#endif
